#ifndef __CREATOR_DIALOGIMPL_H_
#define __CREATOR_DIALOGIMPL_H_

#include <qwidget.h>
#if QT_VERSION >= 0x030000
# include <qptrlist.h>
# ifndef QList
#  define QList QPtrList
# endif
# ifndef QListIterator
#  define QListIterator QPtrListIterator
# endif
#else
# include <qlist.h>
#endif

#include "../../../Core/Scene/src/Object.h"
#include "../../../Core/DataStructures/src/NeighbourHood.h"
#include "../UI/Creator_Dialog.h"

#ifndef MY_PI
#define MY_PI 3.14159265358979323846f
#endif



class Quad {

public:


	int recursion;      // depth of subdivision recursion
	Vector3D a, b, c, d;
	float coords[4];

};

/**
 *
 * @author Mark Pauly
 * @version 1.2
 */
class Creator_DialogImpl : public Creator_DialogBase {
	
    Q_OBJECT

public:

	/**
	 * This method creates an instance of this <code>Creator_DialogImpl</code>, if necessary,
	 * and returns it. Only one instance at a time exists (singleton pattern).
	 *
	 * @return an instance of this <code>Creator_DialogImpl</code>
	 */
	static Creator_DialogImpl *getInstance();

	/**
	 * Destroys the instance of this <code>Creator_DialogImpl</code>, if there
	 * is one.
	 */
	static void destroyInstance();
	
private:

	Creator_DialogImpl (QWidget *parent = 0, const char *name = 0, bool modal = false, WFlags flags = 0);
protected:  // To suppress warnings...
	virtual ~Creator_DialogImpl();
private:



	QList <Quad>     mesh;


private slots:



	void handleCreateSphere();
	void handleCreateEdge();
	void handleCreatePlane();
	void handleCreateCube();
	void handleCreateCylinder();
	void handleCreateFromActive();


};

#endif  // __CREATOR_DIALOGIMPL_H_
